# TPK4186 - Advanced Tools for Performance Engineering
# RandomChoices.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import random
import math

# Q1
print(str(random.randrange(0, 51)*2))

# Q2
numbers = []
for number in range(10, 151, 5):
  if number%7==0:
    numbers.append(number)
print(str(random.choice(numbers)))

# Q3
print(random.sample([i for i in range(10, 51)], 10))
print(random.choices([i for i in range(10, 51)], k=10))


# Q4
# z = p(d) = 1 - exp(-pow(d/alpha, beta))
# d = pow(-log(1 - z), 1/beta)*alpha
def WeibullDelay(z, alpha, beta):
  return alpha*math.pow(-math.log(z), 1/beta)

def RandomProbabilities(n):
  return [random.random() for i in range(0, n)]

alpha = 1000
beta = 3
probabilities = RandomProbabilities(10)
delays = [WeibullDelay(z, alpha, beta) for z in probabilities]
print(probabilities)
print(delays)
